# Bu araç @keyiflerolsun tarafından | @KekikAkademi için yazılmıştır.

from cloudscraper import CloudScraper
from parsel       import Selector
from time         import sleep

from KekikSpatula import KekikSpatula

class Piiz(KekikSpatula):
    """
    Piiz : `piizapp.com` adresinden Güncel Alkol Fiyatlarını hazır formatlarda elinize verir.

    Nitelikler
    ----------
        >>> .veri -> dict | None:
        json verisi döndürür.

        >>> .anahtarlar -> list | None:
        kullanılan anahtar listesini döndürür.

        >>> .nesne -> KekikNesne:
        json verisini python nesnesine dönüştürür.

    Metodlar
    ----------
        >>> .gorsel() -> str | None:
        oluşan json verisini insanın okuyabileceği formatta döndürür.

        >>> .tablo() -> str | None:
        tabulate verisi döndürür.
    """
    def __repr__(self) -> str:
        return f"{__class__.__name__} Sınıfı -- {self.kaynak}'dan Güncel Alkol Fiyatlarını döndürmesi için yazılmıştır.."

    def __init__(self):
        """Güncel Alkol Fiyatlarını `piizapp`'den dızlar."""

        self.kaynak = "piizapp.com"

        while True:
            oturum = CloudScraper()
            istek  = oturum.get(f"https://{self.kaynak}")
            if istek.status_code == 200:
                break
            else:
                sleep(.3)

        secici = Selector(istek.text)

        kekik_json = {"kaynak": self.kaynak, "veri" : [{"tur":"bira","ad":"33cl Bud Depozitosuz Şişe","fiyat":21},{"tur":"bira","ad":"25cl Efes Malt Depozitosuz Şişe","fiyat":21},{"tur":"bira","ad":"45cl Varım Kutu","fiyat":22},{"tur":"bira","ad":"45cl Varım Limonlu Kutu","fiyat":22},{"tur":"bira","ad":"23,7cl Tuborg Kırmızı Shot Special Kutu","fiyat":22.5},{"tur":"bira","ad":"50cl Bud Kutu Şişe","fiyat":23},{"tur":"bira","ad":"50cl Bud Depozitosuz Şişe","fiyat":23},{"tur":"bira","ad":"33cl Tuborg Gold Depozitosuz Şişe","fiyat":23.5},{"tur":"bira","ad":"33cl Tuborg Gold Kutu","fiyat":23.5},{"tur":"bira","ad":"33cl Tuborg Amber Depozitosuz Şişe","fiyat":23.5},{"tur":"bira","ad":"33cl Efes Pilsen Kutu","fiyat":25},{"tur":"bira","ad":"33cl Carlsberg Kutu","fiyat":25.5},{"tur":"bira","ad":"33cl Bomonti Red Ale Depozitosuz Şişe","fiyat":26},{"tur":"bira","ad":"33cl Bomonti Black Depozitosuz Şişe","fiyat":26},{"tur":"bira","ad":"33cl Miller Depozitosuz Şişe","fiyat":26},{"tur":"bira","ad":"33cl Bomonti İpa Depozitosuz Şişe","fiyat":26.5},{"tur":"bira","ad":"50cl Carlsberg Kutu","fiyat":27},{"tur":"bira","ad":"33cl Carlsberg Depozitosuz Şişe","fiyat":27},{"tur":"bira","ad":"50cl Tuborg Gold Depozitolu Şişe","fiyat":27.5},{"tur":"bira","ad":"50cl Efes Malt Depozitolu Şişe","fiyat":27.5},{"tur":"bira","ad":"35cl Frederic Marzen Lager Şişe","fiyat":27.5},{"tur":"bira","ad":"35cl Frederic India Pale Ale Şişe","fiyat":27.5},{"tur":"bira","ad":"35cl Frederic Brown Ale Şişe","fiyat":27.5},{"tur":"bira","ad":"35cl Frederic White Ipa Şişe","fiyat":27.5},{"tur":"bira","ad":"50cl Carlsberg Depozitolu Şişe","fiyat":27.5},{"tur":"bira","ad":"33cl Grimbergen Blonde Depozitosuz Şişe","fiyat":28},{"tur":"bira","ad":"33cl Kronenbourg 1664 Blanc Depozitosuz Şişe","fiyat":28},{"tur":"bira","ad":"33cl SOL Cerveza Depozitosuz Şişe","fiyat":28},{"tur":"bira","ad":"33cl Weihenstephan Depozitosuz Şişe","fiyat":28},{"tur":"bira","ad":"33cl Beck's Depozitosuz Şişe","fiyat":28},{"tur":"bira","ad":"50cl Bomonti Depozitolu Şişe","fiyat":28},{"tur":"bira","ad":"50cl Tuborg Gold Kutu","fiyat":28},{"tur":"bira","ad":"50cl Bomonti Depozitosuz Şişe","fiyat":28.5},{"tur":"bira","ad":"50cl Tuborg Amber Kutu","fiyat":29},{"tur":"bira","ad":"50cl Tuborg Gold Depozitosuz Şişe","fiyat":29},{"tur":"bira","ad":"50cl Efes Malt Kutu","fiyat":29},{"tur":"bira","ad":"50cl Efes Extra Kutu","fiyat":29},{"tur":"bira","ad":"50cl Efes Pilsen Kutu","fiyat":29},{"tur":"bira","ad":"33cl Efes Brewmaster Red Ale Depozitosuz Şişe","fiyat":29.5},{"tur":"bira","ad":"50cl Tuborg Amber Depozitosuz Şişe","fiyat":29.5},{"tur":"bira","ad":"50cl Efes Pilsen Depozitolu Uzun Şişe","fiyat":29.5},{"tur":"bira","ad":"33cl Efes Brewmaster White Ale Depozitosuz Şişe","fiyat":29.5},{"tur":"bira","ad":"50cl Bomonti Filtresiz Depozitosuz Şişe","fiyat":30},{"tur":"bira","ad":"50cl Tuborg Filtresiz Kutu","fiyat":30},{"tur":"bira","ad":"50cl Tuborg Filtresiz Depozitosuz Şişe","fiyat":30},{"tur":"bira","ad":"33cl Grimbergen Double Ambree Depozitosuz Şişe","fiyat":30},{"tur":"bira","ad":"33cl Desperados Depozitosuz Şişe","fiyat":31},{"tur":"bira","ad":"50cl Bomonti Filtresiz Kutu","fiyat":31},{"tur":"bira","ad":"50cl Tuborg Kırmızı Special Kutu","fiyat":31.5},{"tur":"bira","ad":"50cl Beck's Depozitosuz Şişe","fiyat":32},{"tur":"bira","ad":"50cl Beck's Kutu","fiyat":32},{"tur":"bira","ad":"50cl Efes Pilsen Özel Seri Depozitosuz","fiyat":32},{"tur":"bira","ad":"33cl Weihenstephan Vitus Depozitosuz Şişe","fiyat":32},{"tur":"bira","ad":"50cl Miller Kutu","fiyat":33},{"tur":"bira","ad":"50cl Miller Depozitosuz Şişe","fiyat":33},{"tur":"bira","ad":"Efes Glutensiz 50cl","fiyat":33},{"tur":"bira","ad":"50cl Efes Fıçı Yüksek Alkollü Kutu","fiyat":33},{"tur":"bira","ad":"50cl Efes Fıçı Yüksek Alkollü Şişe Depozitosuz","fiyat":34},{"tur":"sarap","ad":"75cl Sevilen Agora Beyaz Şarap","fiyat":39},{"tur":"bira","ad":"35,5cl Corona Extra Şişe","fiyat":40},{"tur":"bira","ad":"100cl Skol Bira Depozitosuz Pet Şişe","fiyat":40},{"tur":"bira","ad":"44cl Guinness Kutu","fiyat":40.5},{"tur":"sarap","ad":"75cl Agora Kırmızı Şarap (Sevilen)","fiyat":41},{"tur":"sarap","ad":"75cl Sevilen Altıntepe Kırmızı Şarap","fiyat":41.5},{"tur":"bira","ad":"33cl Hoegaarden Depozitosuz Şişe","fiyat":42},{"tur":"bira","ad":"33cl Erdinger Depozitosuz Şişe","fiyat":42},{"tur":"bira","ad":"50cl Amsterdam Navigator Depozitosuz Şişe","fiyat":44},{"tur":"bira","ad":"50cl Amsterdam Navigator Kutu","fiyat":44},{"tur":"sarap","ad":"75cl Sevilen Kalecik Karası Kırmızı Şarap","fiyat":44.9},{"tur":"sarap","ad":"75cl Sevilen Majestik Gamay Kırmızı Şarap","fiyat":44.9},{"tur":"sarap","ad":"75cl Sevilen Sultaniye Beyaz Şarap","fiyat":44.9},{"tur":"bira","ad":"33cl Leffe Brune Blonde Depozitosuz Şişe","fiyat":45},{"tur":"bira","ad":"100cl Marmara Gold Depozitosuz Şişe","fiyat":45},{"tur":"bira","ad":"33cl Leffe Brune Depozitosuz Şişe","fiyat":45},{"tur":"sarap","ad":"75cl Sevilen Majestik Öküzgözü Kırmızı","fiyat":45.9},{"tur":"sarap","ad":"75cl Sevilen Majestik Gamay Kırmızı Şarap","fiyat":45.9},{"tur":"bira","ad":"33cl Leffe Radieuse Depozitosuz Şişe","fiyat":48},{"tur":"kokteyl","ad":"14.4 Çilekli Volim","fiyat":50},{"tur":"kokteyl","ad":"14.4 Volim Redbull","fiyat":50},{"tur":"kokteyl","ad":"14.4 Volim Limonlu Alkol","fiyat":50},{"tur":"kokteyl","ad":"Volim Sade","fiyat":50},{"tur":"kokteyl","ad":"Volim Karışık Meyveli","fiyat":50},{"tur":"kokteyl","ad":"Volim Karpuz Aromalı","fiyat":50},{"tur":"kokteyl","ad":"Volim Kola Aromalı","fiyat":50},{"tur":"kokteyl","ad":"Volim Shot Karpuz Çilek","fiyat":50},{"tur":"kokteyl","ad":"Volim Shot Votka İçeçeği","fiyat":50},{"tur":"kokteyl","ad":"Volim Enerji İçeceği Aromalı","fiyat":50},{"tur":"sarap","ad":"18,75cl Villa Doluca Şarap","fiyat":50},{"tur":"bira","ad":"45cl Grolsch Depozitosuz Şişe","fiyat":52},{"tur":"bira","ad":"33cl Duvel Depozitosuz Şişe","fiyat":57},{"tur":"sarap","ad":"75cl Biricik Sek Beyaz Cam Şarap","fiyat":60},{"tur":"sarap","ad":"75cl Biricik Sek Kırmızı CamŞarap","fiyat":60},{"tur":"sarap","ad":"75cl Biricik Sek Kırmızı Cam Şarap","fiyat":60},{"tur":"sarap","ad":"75cl Biricik Sek Beyaz Cam Şarap","fiyat":60},{"tur":"raki","ad":"20cl Saki Rakı Yaş Üzüm","fiyat":64.5},{"tur":"sarap","ad":"75cl Sevilen İsabey Saublanc (Beyaz)","fiyat":79},{"tur":"sarap","ad":"75cl Sevilen İsabey Merlot Şarap","fiyat":79.5},{"tur":"sarap","ad":"75cl Sevilen İsabey Narince Beyaz Şarap","fiyat":79.5},{"tur":"sarap","ad":"75cl Sevilen İsabey Cabarnet","fiyat":79.5},{"tur":"sarap","ad":"100cl Biricik Sek Kırmızı Cam Şarap","fiyat":80},{"tur":"sarap","ad":"100cl Biricik Sek Kırmızı Cam Şarap","fiyat":80},{"tur":"sarap","ad":"100cl Biricik Sek Beyaz Cam Şarap","fiyat":80},{"tur":"sarap","ad":"75cl Mistik Şarap","fiyat":80},{"tur":"sarap","ad":"100cl Biricik Sek Beyaz Cam Şarap","fiyat":80},{"tur":"sarap","ad":"37,5cl Villa Doluca Şarap","fiyat":80},{"tur":"sarap","ad":"37,5cl Doluca Şarap","fiyat":80},{"tur":"raki","ad":"35cl Saki Ginseng","fiyat":88.5},{"tur":"votka","ad":"20cl İstanblue Votka","fiyat":91},{"tur":"likor","ad":"50cl Hare Nane Likörü","fiyat":95},{"tur":"likor","ad":"50cl Hare Acıbadem Likörü","fiyat":95},{"tur":"likor","ad":"50cl Hare Muz Likörü","fiyat":95},{"tur":"likor","ad":"50cl Hare Vişne Likörü","fiyat":95},{"tur":"likor","ad":"50cl Hare Hindistan Cevizi Likörü","fiyat":95},{"tur":"sarap","ad":"75cl Crama Regala Sauvignon Blanc","fiyat":99.9},{"tur":"sarap","ad":"75cl Crama Regala Chardonnay","fiyat":104.9},{"tur":"sarap","ad":"75cl Crama Regala Merlot","fiyat":104.9},{"tur":"sarap","ad":"75cl Crama Regala Cabernet Sauvignon","fiyat":104.9},{"tur":"sarap","ad":"Biricik Sek Kırmızı-Beyaz-Rose Şarap","fiyat":110},{"tur":"likor","ad":"50cl Hare Portakal Likörü","fiyat":110},{"tur":"sarap","ad":"150cl Biricik Galon Kırmızı Cam Şarap","fiyat":118},{"tur":"sarap","ad":"Biricik Sek Kırmızı-Beyaz-Blush Şarap","fiyat":118},{"tur":"sarap","ad":"150cl Biricik Galon Beyaz Cam Şarap","fiyat":118},{"tur":"sarap","ad":"150cl Biricik Galon Kırmızı Cam Şarap","fiyat":118},{"tur":"sarap","ad":"150cl Biricik Galon Beyaz Cam Şarap","fiyat":118},{"tur":"likor","ad":"100cl Hare Kahve, Portakal, Kayısı Likörü","fiyat":125},{"tur":"likor","ad":"100cl Hare Çikolata Likörü","fiyat":125},{"tur":"likor","ad":"100cl Hare Acıbadem, Bitter, Nane Likörü","fiyat":125},{"tur":"likor","ad":"100cl Hare Şeftali, Muz, Tropikal Likörü","fiyat":125},{"tur":"sarap","ad":"75cl Dlc Sultaniye Emir Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Shiraz Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Cab. Sauvıgnon-Merlot Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Moskado Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Kalecik Karası Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Öküzgözü Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Boğazkere Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Sauvıgnon Blanc Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Frenache Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Dlc Narince Şarap","fiyat":130},{"tur":"sarap","ad":"75cl Doluca Şarap","fiyat":130},{"tur":"raki","ad":"35cl Anadolu Boğma Rakı","fiyat":130.5},{"tur":"likor","ad":"35cl Muz Likörü","fiyat":132},{"tur":"sarap","ad":"150cl Biricik Kulplu Kırmızı Şarap","fiyat":132},{"tur":"sarap","ad":"150cl Biricik Kulplu Beyaz Şarap","fiyat":132},{"tur":"likor","ad":"35cl Portakal Likörü","fiyat":132},{"tur":"likor","ad":"35cl Nane Likörü","fiyat":132},{"tur":"likor","ad":"35cl Acıbadem Likörü","fiyat":132},{"tur":"likor","ad":"35cl Ahududu Likörü","fiyat":132},{"tur":"likor","ad":"35cl Vişne Likörü","fiyat":132},{"tur":"likor","ad":"35cl Damla Sakızlı Likör","fiyat":132},{"tur":"votka","ad":"35cl Bazooka Votka","fiyat":139},{"tur":"sarap","ad":"100cl Mistik Şarap","fiyat":140},{"tur":"votka","ad":"35cl İstanblue Votka","fiyat":140},{"tur":"raki","ad":"35cl Ata Rakı","fiyat":140},{"tur":"sarap","ad":"75cl Villa Doluca Şarap","fiyat":140},{"tur":"votka","ad":"20cl Lithuanian Vodka","fiyat":140.9},{"tur":"raki","ad":"20cl Saki Rakı Klasik","fiyat":145.5},{"tur":"raki","ad":"35cl Yekta Rakı","fiyat":149},{"tur":"raki","ad":"35cl Burgaz Rakı","fiyat":149.5},{"tur":"votka","ad":"35cl Wyborowa Votka","fiyat":150},{"tur":"sarap","ad":"75cl Villa Doluca Neo Şarap","fiyat":150},{"tur":"sarap","ad":"200cl Biricik Galon Beyaz Cam Şarap","fiyat":155},{"tur":"sarap","ad":"200cl Biricik Galon Kırmızı Cam Şarap","fiyat":155},{"tur":"raki","ad":"20cl Saki Rakı Altın Seri","fiyat":156},{"tur":"cin","ad":"35cl Gilbey's Cin","fiyat":159},{"tur":"raki","ad":"35cl Tayfa Rakı","fiyat":159.5},{"tur":"votka","ad":"35cl Gilbey's Votka","fiyat":160},{"tur":"cin","ad":"35cl Stirling Cin","fiyat":160.9},{"tur":"viski","ad":"35cl Jack Daniels Tennessee Honey Viski","fiyat":163},{"tur":"viski","ad":"35cl Jack Daniels Tennessee Apple Viski","fiyat":163},{"tur":"raki","ad":"70cl Saki Ginseng","fiyat":164.5},{"tur":"sarap","ad":"100cl Doluca Şarap","fiyat":165},{"tur":"raki","ad":"35cl İzmir Rakısı","fiyat":169},{"tur":"tekila","ad":"35cl Olmeca Blanco Tekila","fiyat":169},{"tur":"votka","ad":"35cl Binboa Votka","fiyat":169},{"tur":"votka","ad":"35cl Stumbra Centenary Vodka","fiyat":170},{"tur":"viski","ad":"35cl Ballantines Finest Viski","fiyat":175},{"tur":"raki","ad":"35cl Saki Rakı Klasik","fiyat":175.2},{"tur":"raki","ad":"35cl İzmir Rakısı Yaş Üzüm","fiyat":175.5},{"tur":"raki","ad":"35cl Yeni Rakı","fiyat":176.75},{"tur":"viski","ad":"20cl Chivas Regal (12 Yıllık) Viski","fiyat":179},{"tur":"kokteyl","ad":"100cl Volim","fiyat":180},{"tur":"raki","ad":"35cl İzmir Rakısı Göbek","fiyat":185},{"tur":"votka","ad":"35cl Smirnoff Red Votka","fiyat":185},{"tur":"tekila","ad":"35cl Olmeca Gold Tekila","fiyat":189},{"tur":"votka","ad":"50cl Bazooka Votka","fiyat":189},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Mojito 100cl","fiyat":190},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Cosmopolitan 100cl","fiyat":190},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Sek On The Beach 100cl","fiyat":190},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Orman Meyveli 100cl","fiyat":190},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Margarita 100cl","fiyat":190},{"tur":"kokteyl","ad":"Bue Hawaii 100cl","fiyat":190},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Kavun 100cl","fiyat":190},{"tur":"kokteyl","ad":"Kırbıyık Kokteyl Karpuz Çilek 100cl","fiyat":190},{"tur":"kokteyl","ad":"Harrley's Irish Cream 100cl","fiyat":190},{"tur":"likor","ad":"100cl Hare Portakal Likörü","fiyat":190},{"tur":"tekila","ad":"70cl El Jimador Blanco Tequila","fiyat":195},{"tur":"votka","ad":"50cl İstanblue Votka","fiyat":195},{"tur":"raki","ad":"20cl Saki Rakı Siyah Üzüm","fiyat":195.5},{"tur":"raki","ad":"35cl Yeni Rakı Yeni Seri","fiyat":199},{"tur":"raki","ad":"35cl Tekirdağ Rakı","fiyat":199},{"tur":"cin","ad":"35cl Gordon's Dry Cin","fiyat":199},{"tur":"raki","ad":"35cl Saki Rakı Altın Seri","fiyat":199.5},{"tur":"raki","ad":"35cl Tekirdağ Rakı Trakya Serisi","fiyat":199.5},{"tur":"votka","ad":"35cl Lithuanian Vodka","fiyat":199.9},{"tur":"raki","ad":"35cl Efe Yaş Üzüm Rakı","fiyat":200},{"tur":"raki","ad":"35cl Tekirdağ Rakı Kavrulmuş Anason","fiyat":200},{"tur":"raki","ad":"35cl Saki Rakı Yaş Üzüm","fiyat":200.5},{"tur":"viski","ad":"35cl Ballantines 12 Yıl Viski","fiyat":205},{"tur":"votka","ad":"50cl Wyborowa Votka","fiyat":205},{"tur":"viski","ad":"35cl Jack Daniels Old No.7 Viski","fiyat":205.5},{"tur":"raki","ad":"35cl Tekirdağ Rakı Altın Seri","fiyat":209},{"tur":"votka","ad":"35cl Absolut Vodka","fiyat":209},{"tur":"raki","ad":"35cl Efe Gold Rakı","fiyat":209.5},{"tur":"tekila","ad":"70cl El Jimador Reposado Tequila","fiyat":210},{"tur":"cin","ad":"35cl Beefeater Cin","fiyat":210},{"tur":"likor","ad":"100cl Garrone Ricard Likör","fiyat":210},{"tur":"raki","ad":"35cl Yeni Rakı Ustaların Karışımı","fiyat":215.5},{"tur":"viski","ad":"35cl Bell's Viski","fiyat":219},{"tur":"raki","ad":"50cl Tayfa Rakı","fiyat":219},{"tur":"raki","ad":"35cl Efe Çilingir Xtra Rakı","fiyat":220.5},{"tur":"likor","ad":"100cl Garrone Rosso Likör","fiyat":225},{"tur":"likor","ad":"35cl Jagermeister","fiyat":225},{"tur":"likor","ad":"100cl Garrone Bianco Dry Likör","fiyat":225},{"tur":"votka","ad":"50cl Stumbra Centenary Vodka","fiyat":225.9},{"tur":"raki","ad":"35cl Efe Tek İmbik Rakı","fiyat":226},{"tur":"raki","ad":"35cl Yeni Rakı Âlâ","fiyat":229},{"tur":"raki","ad":"50cl Burgaz Rakı","fiyat":229},{"tur":"raki","ad":"35cl Kulüp Rakı","fiyat":229.5},{"tur":"cin","ad":"50cl Stirling Cin","fiyat":230.9},{"tur":"sarap","ad":"150cl Mistik Şarap","fiyat":235},{"tur":"tekila","ad":"50cl Olmeca Blanco Tekila","fiyat":235},{"tur":"raki","ad":"70cl Anadolu Boğma Rakı","fiyat":235},{"tur":"raki","ad":"35cl Beylerbeyi Göbek Rakısı","fiyat":235},{"tur":"raki","ad":"50cl İzmir Rakısı","fiyat":239.5},{"tur":"sarap","ad":"300cl Biricik Kulplu Beyaz Şarap","fiyat":240},{"tur":"sarap","ad":"Biricik Suni Yarı Köpüren Şarap (Beyaz-Rose)","fiyat":240},{"tur":"raki","ad":"35cl Altınbaş Rakı","fiyat":240},{"tur":"sarap","ad":"300cl Biricik Kulplu Kırmızı Şarap","fiyat":240},{"tur":"viski","ad":"50cl Ballantines Finest Viski","fiyat":245},{"tur":"raki","ad":"50cl İzmir Rakısı Yaş Üzüm","fiyat":245},{"tur":"viski","ad":"35cl J&B Viski","fiyat":245},{"tur":"viski","ad":"35cl Johnnie Walker Black Label Viski","fiyat":245},{"tur":"raki","ad":"35cl Saki Rakı Siyah Üzüm","fiyat":245.5},{"tur":"raki","ad":"35cl Efe Klasik Rakı","fiyat":245.5},{"tur":"votka","ad":"50cl Smirnoff Red","fiyat":249.5},{"tur":"raki","ad":"50cl Efe Klasik Rakı","fiyat":249.5},{"tur":"raki","ad":"35cl Efe Çilingir Xtra Yaş Üzüm Rakı","fiyat":249.9},{"tur":"raki","ad":"35cl Efe 3 Distile Rakı","fiyat":250},{"tur":"raki","ad":"35cl Efe Geleneksel Rakı","fiyat":250.9},{"tur":"raki","ad":"50cl Saki Rakı Klasik","fiyat":250.9},{"tur":"raki","ad":"35cl Efe Çilingir Rakı","fiyat":251.9},{"tur":"raki","ad":"35cl Efe Sarı Zeybek Rakı","fiyat":257},{"tur":"votka","ad":"70cl Bazooka Votka","fiyat":260},{"tur":"votka","ad":"70cl İstanblue Votka","fiyat":265.5},{"tur":"votka","ad":"70cl Lithuanian Vodka","fiyat":269.9},{"tur":"raki","ad":"70cl Ata Rakı","fiyat":271},{"tur":"raki","ad":"50cl Tekirdağ Rakı","fiyat":275},{"tur":"votka","ad":"70cl Wyborowa Votka","fiyat":275},{"tur":"viski","ad":"35cl Johnnie Walker Red Label Viski","fiyat":275},{"tur":"viski","ad":"50cl Jack Daniels Old No.7 Viski","fiyat":279},{"tur":"viski","ad":"35cl Chivas Regal (12 Yıllık) Viski","fiyat":279.4},{"tur":"votka","ad":"50cl Lithuanian Vodka","fiyat":280.9},{"tur":"raki","ad":"50cl Efe Yaş Üzüm Rakı","fiyat":281},{"tur":"viski","ad":"50cl Ballantines 12 Yıl Viski","fiyat":285},{"tur":"viski","ad":"50cl Bell's Viski","fiyat":285.9},{"tur":"votka","ad":"50cl Absolut Vodka","fiyat":288},{"tur":"raki","ad":"50cl Yeni Rakı Yeni Seri","fiyat":289},{"tur":"raki","ad":"50cl Yeni Rakı","fiyat":289.5},{"tur":"raki","ad":"50cl Efe Gold Rakı","fiyat":295},{"tur":"votka","ad":"70cl Binboa Pier Ginger Votka","fiyat":295},{"tur":"votka","ad":"70cl Binboa Red Orange","fiyat":295},{"tur":"votka","ad":"50cl Binboa Votka","fiyat":295},{"tur":"votka","ad":"70cl Binboa Red Apple","fiyat":295},{"tur":"votka","ad":"70cl Binboa Satsuma Votka","fiyat":295},{"tur":"votka","ad":"70cl Binboa Mojito","fiyat":295},{"tur":"votka","ad":"70cl Gilbey's Votka","fiyat":295},{"tur":"raki","ad":"50cl Tekirdağ Rakı Altın Seri","fiyat":295},{"tur":"raki","ad":"50cl Saki Rakı Yaş Üzüm","fiyat":295.9},{"tur":"raki","ad":"50cl Saki Rakı Altın Seri","fiyat":295.9},{"tur":"raki","ad":"70cl Tayfa Rakı","fiyat":299},{"tur":"raki","ad":"70cl Burgaz Rakı","fiyat":300},{"tur":"viski","ad":"70cl Jack Daniels Tennessee Honey Viski","fiyat":300},{"tur":"viski","ad":"70cl Jack Daniels Tennessee Apple Viski","fiyat":300},{"tur":"cin","ad":"75cl Stirling Cin","fiyat":300.9},{"tur":"raki","ad":"50cl Beylerbeyi Göbek Rakısı","fiyat":305},{"tur":"votka","ad":"70cl Smirnoff North","fiyat":309},{"tur":"votka","ad":"70cl Stumbra Centenary Vodka","fiyat":310.9},{"tur":"viski","ad":"70cl Jack Daniels Special Edition Viski","fiyat":320},{"tur":"raki","ad":"70cl Yekta Rakı","fiyat":325},{"tur":"tekila","ad":"70cl Olmeca Blanco Tekila","fiyat":325},{"tur":"tekila","ad":"70cl Olmeca Dark Chocolate","fiyat":325},{"tur":"raki","ad":"70cl İzmir Rakısı","fiyat":325},{"tur":"raki","ad":"70cl İzmir Rakısı Yaş Üzüm","fiyat":330},{"tur":"viski","ad":"70cl Ballantines Finest Viski","fiyat":330},{"tur":"likor","ad":"70cl Jagermeister","fiyat":335},{"tur":"raki","ad":"70cl İzmir Rakısı Göbek","fiyat":335},{"tur":"raki","ad":"70cl Saki Rakı Klasik","fiyat":335.5},{"tur":"viski","ad":"50cl Johnnie Walker Black Label Viski","fiyat":339},{"tur":"raki","ad":"70cl Efe Klasik Rakı","fiyat":339.5},{"tur":"raki","ad":"70cl Efe 3 Distile Rakı","fiyat":340.5},{"tur":"raki","ad":"50cl Saki Rakı Siyah Üzüm","fiyat":345.5},{"tur":"votka","ad":"70cl Smirnoff Red","fiyat":349},{"tur":"votka","ad":"70cl Smirnoff Espresso","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Green Apple","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Peppermint (Nane)","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Citrus (Narenciye)","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Rasberry (Ahududu)","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Apple (Elma) Red","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Vanilla (Vanilya)","fiyat":359},{"tur":"votka","ad":"70cl Smirnoff Orange (Portakal)","fiyat":359},{"tur":"viski","ad":"50cl Chivas Regal (12 Yıllık) Viski","fiyat":359},{"tur":"tekila","ad":"70cl Olmeca Gold Tekila","fiyat":360},{"tur":"viski","ad":"70cl Ballantine's 7 İskoç Viski","fiyat":360},{"tur":"votka","ad":"100cl Bazooka Votka","fiyat":360},{"tur":"raki","ad":"70cl Yeni Rakı Yeni Seri","fiyat":369},{"tur":"votka","ad":"100cl İstanblue Votka","fiyat":370},{"tur":"raki","ad":"70cl Efe Yaş Üzüm Rakı","fiyat":373},{"tur":"cin","ad":"70cl Gilbey's Cin","fiyat":375},{"tur":"raki","ad":"70cl Tekirdağ Rakı","fiyat":375.5},{"tur":"raki","ad":"70cl Saki Rakı Yaş Üzüm","fiyat":375.5},{"tur":"raki","ad":"70cl Tekirdağ Rakı Trakya Serisi","fiyat":375.5},{"tur":"votka","ad":"70cl Absolut Vodka Mandrin","fiyat":377},{"tur":"votka","ad":"70cl Absolut Vodka Vanilia","fiyat":377},{"tur":"votka","ad":"70cl Absolut Vodka Raspberri","fiyat":377},{"tur":"votka","ad":"70cl Absolut Extrakt Vodka","fiyat":377},{"tur":"votka","ad":"70cl Absolut Vodka","fiyat":377},{"tur":"votka","ad":"70cl Absolut Lime Vodka","fiyat":377},{"tur":"votka","ad":"70cl Absolut Vodka Apeach","fiyat":377},{"tur":"votka","ad":"70cl Absolut Citron Vodka","fiyat":377},{"tur":"votka","ad":"70cl Absolut Pears Vodka","fiyat":377},{"tur":"raki","ad":"70cl Yeni Rakı","fiyat":379.5},{"tur":"viski","ad":"70cl Jack Daniels Old No.7 Viski","fiyat":380},{"tur":"viski","ad":"50cl J&B Viski","fiyat":380},{"tur":"viski","ad":"50cl Johnnie Walker Red Label Viski","fiyat":380},{"tur":"likor","ad":"35cl Cointreau Likör","fiyat":381},{"tur":"votka","ad":"100cl Wyborowa Votka","fiyat":385},{"tur":"viski","ad":"70cl Ballantines 12 Yıl Viski","fiyat":390},{"tur":"cin","ad":"70cl Beefeater Pink Cin","fiyat":395},{"tur":"raki","ad":"70cl Saki Rakı Altın Seri","fiyat":395.9},{"tur":"cin","ad":"70cl Beefeater Cin","fiyat":396},{"tur":"viski","ad":"70cl Bell's Viski","fiyat":399},{"tur":"cin","ad":"70cl Gordon's Dry Cin","fiyat":399},{"tur":"raki","ad":"70cl Efe Gold Rakı","fiyat":399},{"tur":"raki","ad":"70cl Tekirdağ Rakı Altın Seri","fiyat":399},{"tur":"raki","ad":"70cl Tekirdağ Rakı Kavrulmuş Anason","fiyat":400},{"tur":"votka","ad":"100cl Lithuanian Vodka","fiyat":400.9},{"tur":"viski","ad":"100cl Jack Daniels Tennessee Honey Viski","fiyat":405},{"tur":"viski","ad":"100cl Jack Daniels Tennessee Apple Viski","fiyat":405},{"tur":"raki","ad":"70cl Yeni Rakı Ustaların Karışımı","fiyat":409},{"tur":"raki","ad":"100cl Tayfa Rakı","fiyat":410.5},{"tur":"raki","ad":"70cl Efe Tek İmbik Rakı","fiyat":415},{"tur":"votka","ad":"70cl Binboa Votka","fiyat":419},{"tur":"cin","ad":"100cl Stirling Cin","fiyat":419.9},{"tur":"votka","ad":"100cl Gilbey's Votka","fiyat":420},{"tur":"raki","ad":"70cl Efe Geleneksel Rakı","fiyat":420.5},{"tur":"raki","ad":"70cl Efe Çilingir Rakı","fiyat":425.5},{"tur":"raki","ad":"70cl Beylerbeyi Göbek Rakısı","fiyat":429},{"tur":"raki","ad":"70cl Kulüp Rakı","fiyat":430},{"tur":"raki","ad":"70cl Yeni Rakı Âlâ","fiyat":435},{"tur":"votka","ad":"100cl Stumbra Centenary Vodka","fiyat":435.9},{"tur":"tekila","ad":"70cl Olmeca Altos Plata Tekila","fiyat":440},{"tur":"raki","ad":"70cl Efe Çilingir Xtra Rakı","fiyat":440.9},{"tur":"raki","ad":"100cl Saki Rakı Klasik","fiyat":440.9},{"tur":"raki","ad":"70cl Saki Rakı Siyah Üzüm","fiyat":445.5},{"tur":"viski","ad":"70cl Johnnie Walker Black Label Viski","fiyat":449},{"tur":"raki","ad":"100cl İzmir Rakısı","fiyat":449.5},{"tur":"raki","ad":"70cl Efe Çilingir Xtra Yaş Üzüm Rakı","fiyat":449.9},{"tur":"tekila","ad":"70cl Olmeca Altos Reposadd","fiyat":450},{"tur":"raki","ad":"100cl Yekta Rakı","fiyat":450.5},{"tur":"likor","ad":"100cl Jagermeister","fiyat":452.5},{"tur":"viski","ad":"100cl Ballantines Finest Viski","fiyat":455},{"tur":"tekila","ad":"100cl Olmeca Blanco Tekila","fiyat":455},{"tur":"raki","ad":"100cl İzmir Rakısı Yaş Üzüm","fiyat":459.5},{"tur":"raki","ad":"70cl Altınbaş Rakı","fiyat":460},{"tur":"raki","ad":"70cl Efe Sarı Zeybek Rakı","fiyat":469.5},{"tur":"cin","ad":"70cl Gordon's Pink Cin","fiyat":475},{"tur":"raki","ad":"100cl Efe Klasik Rakı","fiyat":475.5},{"tur":"viski","ad":"70cl Chivas Regal (12 Yıl) Viski","fiyat":479},{"tur":"cin","ad":"100cl Gilbey's Cin","fiyat":481},{"tur":"viski","ad":"70cl Chivas Regal (13 Yıllık) İskoç Viskisi","fiyat":490},{"tur":"viski","ad":"70cl Jack Daniels Single Barrel Viski","fiyat":495},{"tur":"votka","ad":"100cl Smirnoff Red","fiyat":499},{"tur":"raki","ad":"100cl Yeni Rakı","fiyat":499.5},{"tur":"raki","ad":"100cl Yeni Rakı Yeni Seri","fiyat":499.5},{"tur":"viski","ad":"70cl J&B Viski","fiyat":500},{"tur":"viski","ad":"70cl Johnnie Walker Red Label Viski","fiyat":500},{"tur":"raki","ad":"100cl Efe Yaş Üzüm Rakı","fiyat":504.5},{"tur":"viski","ad":"100cl Jack Daniels Old No.7 Viski","fiyat":515},{"tur":"raki","ad":"100cl Tekirdağ Rakı","fiyat":519},{"tur":"votka","ad":"100cl Absolut Vodka","fiyat":525},{"tur":"raki","ad":"100cl Saki Rakı Yaş Üzüm","fiyat":525.9},{"tur":"raki","ad":"70cl Tekirdağ Rakı No. 10","fiyat":529},{"tur":"cin","ad":"70cl Malfy Con Limone","fiyat":535},{"tur":"cin","ad":"70cl Malfy Gın Rose","fiyat":535},{"tur":"cin","ad":"70cl Malfy Originale Cin","fiyat":535},{"tur":"viski","ad":"100cl Ballantines 12 Yıl Viski","fiyat":540},{"tur":"raki","ad":"100cl Tekirdağ Rakı Altın Seri","fiyat":549.5},{"tur":"raki","ad":"100cl Efe Gold Rakı","fiyat":549.5},{"tur":"raki","ad":"100cl Saki Rakı Altın Seri","fiyat":549.9},{"tur":"viski","ad":"100cl Bell's Viski","fiyat":550.5},{"tur":"raki","ad":"100cl Beylerbeyi Göbek Rakısı","fiyat":569},{"tur":"raki","ad":"100cl Efe Çilingir Rakı","fiyat":579.5},{"tur":"raki","ad":"100cl Efe Tek İmbik Rakı","fiyat":580.5},{"tur":"cin","ad":"70cl Tanqueray Cin (London Dry Gin)","fiyat":583},{"tur":"tekila","ad":"70cl Avion Silver","fiyat":600},{"tur":"cin","ad":"70cl Tanqueray Flor De Sevilla Cin","fiyat":625},{"tur":"viski","ad":"100cl Johnnie Walker Black Label Viski","fiyat":639},{"tur":"viski","ad":"70cl Chivas Regal (15 Yıllık) Viski","fiyat":649},{"tur":"tekila","ad":"70cl Avion Reposadd","fiyat":650},{"tur":"viski","ad":"70cl Johnnie Walker Double Black Viski","fiyat":650},{"tur":"viski","ad":"70cl Ballantine's 17 İskoç Viski","fiyat":660},{"tur":"viski","ad":"150cl Ballantines Finest Viski","fiyat":685},{"tur":"viski","ad":"100cl Chivas Regal (12 Yıl) Viski","fiyat":690},{"tur":"viski","ad":"175cl Jack Daniels Old No.7 Viski","fiyat":695},{"tur":"viski","ad":"100cl Johnnie Walker Red Label Viski","fiyat":699},{"tur":"viski","ad":"100cl J&B Viski","fiyat":699},{"tur":"viski","ad":"70cl Johnnie Walker Gold Label Reserve Viski","fiyat":699},{"tur":"likor","ad":"50cl Cointreau Likör","fiyat":700},{"tur":"cin","ad":"100cl Bombay Sapphire Cin","fiyat":720},{"tur":"viski","ad":"50cl Chivas Regal (18 Yıllık) Viski","fiyat":750},{"tur":"tekila","ad":"70cl Don Julio Tequila","fiyat":750},{"tur":"cin","ad":"70cl Tanqueray No: 10 Cin","fiyat":760},{"tur":"raki","ad":"150cl Yeni Rakı","fiyat":799},{"tur":"viski","ad":"70cl Jack Daniels No.27 Gold Viski","fiyat":800},{"tur":"raki","ad":"100cl Efe Geleneksel Rakı","fiyat":807},{"tur":"raki","ad":"70cl Efe Organik Rakı","fiyat":840.5},{"tur":"raki","ad":"100cl Efe Çilingir Xtra Rakı","fiyat":849.5},{"tur":"votka","ad":"70cl Absolut Elyx Vodka","fiyat":860},{"tur":"viski","ad":"150cl J&B Viski","fiyat":875},{"tur":"raki","ad":"70cl Efe 5 Yıllık Rakı","fiyat":895},{"tur":"viski","ad":"70cl Chivas Mizunara İskoç Viskisi","fiyat":940},{"tur":"likor","ad":"100cl Cointreau Likör","fiyat":951},{"tur":"viski","ad":"70cl Johnnie Walker Green Label 15 Yıllık Viski","fiyat":980},{"tur":"votka","ad":"175cl Absolut Vodka","fiyat":985},{"tur":"viski","ad":"150cl Johnnie Walker Black Label Viski","fiyat":995},{"tur":"viski","ad":"70cl Chivas Regal (18 Yıllık) Viski","fiyat":1000},{"tur":"viski","ad":"70cl Johnnie Walker 18 Yıllık Viski","fiyat":1050},{"tur":"viski","ad":"150cl Johnnie Walker Red Label Viski","fiyat":1075},{"tur":"viski","ad":"300cl Jack Daniels Old No.7 Viski","fiyat":1175},{"tur":"viski","ad":"70cl Ballantines 21 Yıl Viski","fiyat":1250},{"tur":"raki","ad":"70cl Saki Rakı Premium","fiyat":1250},{"tur":"viski","ad":"175cl Chivas Regal (12 Yıl) Viski","fiyat":1250},{"tur":"viski","ad":"100cl Jack Daniels Sinatra Select Viski","fiyat":1300},{"tur":"viski","ad":"300cl Ballantines Finest Viski","fiyat":1600},{"tur":"viski","ad":"300cl Chivas Regal (12 Yıllık) Viski","fiyat":1850},{"tur":"votka","ad":"150cl Absolut Elyx Vodka","fiyat":1860},{"tur":"viski","ad":"300cl Johnnie Walker Black Label Viski","fiyat":1929},{"tur":"viski","ad":"70cl Chivas Regal Royal Salute 21 İskoç Viskisi","fiyat":2150},{"tur":"viski","ad":"300cl Johnnie Walker Red Label Viski","fiyat":2200},{"tur":"viski","ad":"300cl Chivas Regal (12 Yıllık)","fiyat":2229},{"tur":"votka","ad":"450cl Absolut Vodka Blue","fiyat":2725},{"tur":"tekila","ad":"70cl Don Julio 1942 Tequila","fiyat":3000},{"tur":"votka","ad":"300cl Absolut Elyx Vodka","fiyat":3650},{"tur":"viski","ad":"70cl Johnnie Walker Blue Label Viski","fiyat":4000},{"tur":"viski","ad":"70cl Chivas Regal (25 Yıllık) Viski","fiyat":4990},{"tur":"votka","ad":"450cl Absolut Elyx Vodka","fiyat":6000},{"tur":"viski","ad":"70cl Johnnie Walker Sons King George V Viski","fiyat":7000}]}

        if secici.xpath("//div[@class='products']/div"):
            kekik_json["veri"] = [
                {
                    "tur"   : alkol.xpath("./@class").get().split()[-1],
                    "ad"    : alkol.xpath("normalize-space(.//div[@class='product-name'])").get().replace(" Fiyatı", ""),
                    "fiyat" : float(alkol.xpath("normalize-space(.//div[@class='product-price'])").get())
                }  for alkol in secici.xpath("//div[@class='products']/div")
            ]

        self.kekik_json = kekik_json if kekik_json["veri"] != [] else None